# -*- perl -*-

# Copyright (c) 2002 by Jeff Weisberg
# Author: Jeff Weisberg <argus @ tcp4me.com>
# Date: 2002-Apr-02 13:52 (EST)
# Function: control channel listener
#
# $Id: CListen_Local.pm,v 1.11 2002/11/19 23:42:02 jaw Exp $

package CListen_Local;
use Fcntl;
use Socket;
@ISA = qw(BaseIO);

# The open ear of youth doth always listen;
#	-- Shakespeare King Richard II

$doc = {
    package => __PACKAGE__,
    file    => __FILE__,
    isa     => [@ISA],
    methods => {
    },
    fields  => {
    },
};

sub new {
    my $class = shift;
    my( $me, $fh, $i, $p );

    $me = {};
    bless $me; # not 'bless $me, $class'
    $me->{type} = 'CListen_L';
    $me->{fd} = $fh = BaseIO::anon_fh();

    my $file = "$::datadir/control";
    # perl doesn't know that NetBSD renamed this PF_LOCAL...
    socket($fh, PF_UNIX, SOCK_STREAM, 0);
    unlink $file;
    # Do as I bid you; shut doors after you:
    # Fast bind, fast find;
    #   -- Shakespeare, Merchant of Venice
    $i = bind($fh, sockaddr_un($file));
    return ::warning( "Cannot bind Control Port unix/$file: $!" )
	unless $i;
	
    listen( $fh, 10 );
    $me->wantread(1);
    $me->wantwrit(0);
    $me->settimeout(0);
    $me->baseio_init();

    $me;
}

# becomes readable if someone connects - create a new control channel
sub readable {
    my $me = shift;
    my( $fh, $nfh, $c, $i );

    $fh  = $me->{fd};
    $nfh = BaseIO::anon_fh();
    $i = accept( $nfh, $fh );
    return ::loggit( "Control accept failed - $!", 0 )
	unless $i;
    
    $c = Control->new( $nfh, 'pf_unix' );
}

################################################################
# class global init
################################################################
Doc::register( $doc );

1;
