#!/usr/local/bin/perl
# -*- perl -*-

# Copyright (c) 2002 by Jeff Weisberg
# Author: Jeff Weisberg <argus @ tcp4me.com>
# Date: 2002-Nov-06 17:57 (EST)
# Function: system monitoring agent
#
# $Id: sys_agent.pl,v 1.4 2002/11/19 23:42:08 jaw Exp $

# run from inetd.conf

# uptime, disk used %, load ave, mailq
# shouldn't people be running snmpd instead?

chop($line = <STDIN>);
($what, $arg) = split /\s+/, $line, 2;

if( $what eq 'load' ){
    if( open(F, "/proc/loadavg") ){
	my $l = <F>;
	($l) = split /\s+/, $l;
	print "$l\n";
	close F;
    }elsif( open(F, "/kern/loadavg") ){
	my $l = <F>;
	my(@a) = split /\s+/, $l;
	$l = $a[0] / $a[3];
	print "$l\n";
	close F;
    }else{
	my $up = output_of_command( 'uptime' );
	$up =~ s/.*:\s*([\d\.]+).*\n?/$1/;
	print "$up\n";
    }
}

if( $what eq 'uptime' ){
    if( open(F, "/proc/uptime") ){
	my $l = <F>;
	($l) = split /\s+/, $l;
	print "$l\n";
	close F;
    }elsif( open(F, "/kern/boottime") ){
	my $l = <F>;
	$l = $^T - $l;
	print "$l\n";
	close F;
    }else{
	# ???
    }
}

if( $what eq 'disk' ){
    my $df = output_of_command( 'df', $arg );
    $df =~ s/.*\s+(\d+)%.*\n?/$1/s;
    print "$df\n";
}

if( $what eq 'mailq' ){

}

sub output_of_command {
    my $cmd = shift;
    my @arg = @_;
    my( $f );

    # we don't just `$cmd $arg` in case we have a naughty $arg...
    open(F, "-|") || exec($cmd, @arg);
    while( <F> ){
	$f .= $_;
    }
    close F;
    $f;
}

